;; (find-evariable 'Man-notify-method)
;; (find-efile "man.el" "defun Man-notify-when-ready")
;;
(defun ee-install-find-man.el-hack ()
  (load-library "man")
  (fset 'Man-notify-when-ready-orig (symbol-function 'Man-notify-when-ready))
  (defun Man-notify-when-ready (man-buffer)
    (switch-to-buffer man-buffer)
    (apply 'ee-goto-position ee-pos-spec-list-for-find-man.el)
    (setq pos-spec-man nil))
  )


;; (find-es "emacs" "menu-bar")
(defvar menu-bar-eev-menu (make-sparse-keymap "(eev)"))

(define-key menu-bar-eev-menu [end-of-line-then-eval-last-sexp]
  '("C-e + eval-last-sexp" . end-of-line-then-eval-last-sexp))
(define-key menu-bar-eev-menu [eval-last-sexp]
  '("eval-last-sexp" . eval-last-sexp))
(define-key menu-bar-eev-menu [kill-buffer]
  '("kill-buffer (M-k)" . kill-buffer))
(define-key menu-bar-eev-menu [tutorial-pt]
  '("Tutorial (pt_BR)" . (lambda () (interactive)
			   (find-eev "e/tutorial.pt.e"))))
(define-key menu-bar-eev-menu [tutorial]
  '("Tutorial" . (lambda () (interactive)
		   (find-eev "e/tutorial.e"))))
(define-key menu-bar-eev-menu [key-help]
  '("Key help" . (lambda () (interactive)
		   (find-eev "e/keys.e"))))


(defun ee-invade-global-menu-bar ()
  "Add an \"(eev)\" entry to the top-level menu bar."
  (interactive)
  (define-key global-map [menu-bar eev] (cons "(eev)" menu-bar-eev-menu)))

(defun ee-invade-global-namespace ()
  "Define some aliases to hyperlink functions with long names."
  (interactive)
  (defalias 'to   'ee-to)
  (defalias 'back 'ee-back)
  (defalias 'inn  'ee-insert-info-hyperlink)
  (defalias 'dff  'ee-convert-to-debian-link))

(defun ee-invade-global-keymap ()
  "Set some keys in the global to functions related to `eev'."
  (interactive)
  (global-set-key [f3]   'ee-bounded)
  (global-set-key "\M-k" 'kill-buffer)
  (global-set-key "\M-E" 'end-of-line-then-eval-last-sexp)
  (global-set-key "\M-e" 'end-of-line-then-eval-last-sexp)
  (global-set-key "\M-A" 'back))

;; (find-eev "demo/.emacs")
;; (find-eev "eev-util" "install_dotfiles")
;; (find-angg ".emacs" "load_eev.el")

(defun eev-install-aggressively ()
  (interactive)
  (ee-invade-global-namespace)
  (ee-invade-global-keymap)
  (ee-invade-global-menu-bar)
  (ee-install-find-man.el-hack))






;; Local Variables:
;; coding:               no-conversion
;; ee-anchor-format:     "%s"
;; ee-charset-indicator: ""
;; End:
