;;;;
;;;; Variables related to eev-save.el
;;;;

(defvar ee-file "~/eev/ee.sh"
  "The file where `eev' saves its temporary shell script.
See the docs on the function `eev'.")

(defvar ee-file-generic "~/eev/ee.generic"
  "The file used for all \"ee\" commands based on the generic interface.
The command `eeg' saves the region in this file.\n
When you run an application through the \"eeg\" support script (written in
Expect) you are able to paste lines from this file to the application.")

(defvar ee-file-gdb "~/eev/ee.gdb"
  "The file used for saving temporary gdb (e-)scripts.")

;; Variables used by `eelatex':
;;
(defvar eelatex-pre "\\documentclass{book}\n\\begin{document}\n")
(defvar eelatex-post "\n\\end{document}\n")
(defvar eelatex-file "~/tmp/tmp.tex")
(defvar eelatex-eevscript "cd ~/tmp/; latex tmp.tex")

;; For `ee-bounded':
;;
(defvar ee-temp-bounded-function 'eev-bounded
  "The function that \\[ee-bounded] will execute.
All standard `eexxx-bounded' functions set this variable when they are
run; `eev-bounded' set it to `eev-bounded', `eeg-bounded' to
`eeg-bounded', and so on.")

(put 'ee-temp-bounded-function 'safe-local-variable t)

(defvar ee-delimiter-hash "\n#-\n"
  "The delimiter string used by `eev-bounded' and other similar functions.
All `eexxx-bounded' functions that are used for languages where
comments start with a `#' use this string.\n
The default value for this variable may change in future versions. For
more information on the best way to set a value for it, follow this
link: (find-enode \"File Variables\")")

(defvar ee-delimiter-percent "\n%-\n"
  "The delimiter string used by `eelatex-bounded' and similar functions.
All `eexxx-bounded' functions that are used for languages where
comments start with a `%' use this string.\n
The default value for this variable may change in future versions. For
more information on the best way to set a value for it, follow this
link: (find-enode \"File Variables\")")



(defvar ee-anchor-format "<<%s>>"
  "Hyperlink functions based on `find-anchor' use this string to make a string to search for.\n
The default value for this variable may change in future versions. For
more information on the best way to set a value for it, follow this
link: (find-enode \"File Variables\")")

(defvar ee-comment-format "# %s\n"
  "The format used by `inn' to insert \"find-xxxnode\" lines.")

(defvar ee-arg nil
  "A variable used to pass a parameter to hyperlink functions.
See the documentation for `end-of-line-then-eval-last-sexp' to
understand how the trick works.")




;; Local Variables:
;; coding:               no-conversion
;; ee-anchor-format:     "%s"
;; End:
