(defun ee-goto-position (&optional pos-spec &rest rest)
  (if (or pos-spec rest)
      (goto-char (point-min)))
  (when pos-spec
    (cond ((numberp pos-spec)
	   (forward-line (1- pos-spec)))
	  ((stringp pos-spec)
	   (search-forward pos-spec))
	  (t (error "This is not a valid pos-spec: %S" pos-spec)))
    (if rest (ee-goto-rest rest))))

(defun ee-goto-rest (list)
  (cond ((stringp (car list))
	 (search-forward (car list))
	 (ee-goto-rest (cdr list)))))

(defvar ee-find-man-flag nil)
(defvar ee-find-man-pos-spec-list nil)

(defadvice Man-notify-when-ready (around find-man activate)
  (if (not ee-find-man-flag)
      ad-do-it
    (setq ee-find-man-flag nil)
    (switch-to-buffer (ad-get-arg 0))
    (apply 'ee-goto-position ee-find-man-pos-spec-list)))

(defun find-man (manpage &rest pos-spec-list)
  (setq ee-find-man-flag t
	ee-find-man-pos-spec-list pos-spec-list)
    (man manpage))



;; (find-man2 "ls" "--human-readable")
;; (switch-to-buffer "*Messages*")

;; (find-elnode "Formatting Strings")

;; Quando o buffer man ls no existe roda
;; Man-bgproc-sentinel por fora, e dentro dele o
;; Man-notify-when-ready.

;; Quando o buffer man ls existe roda s o
;; Man-notify-when-ready.

;; (Man-notify-method 'pushy))
;; (kill-buffer "*Messages*")

;; (find-eevfile "eev-hybrids.el" "defun ee-install-find-man.el-hack")
;; (find-es "emacs" "man" "(fset ")
;; (find-efile "man.el" "set-process-sentinel")
;; (find-efile "man.el" "defun Man-bgproc-sentinel")
;; (find-efile "man.el" "defun Man-notify-when-ready")
;; (find-man2 "ls" "--human-readable")
;; (find-elnode "Time of Day")

