;; From rubikitch@ruby-lang.org  Wed Jul 30 08:00:24 2003
;; Date: Wed, 30 Jul 2003 19:59:25 +0900 (JST)
;; From: rubikitch <rubikitch@ruby-lang.org>
;; To: edrx@sucuri.mat.puc-rio.br
;; Subject: my eev

;; > From: Eduardo Nahum Ochs <edrx@sucuri.mat.puc-rio.br>
;; > Subject: eev and etc
;; > Date: Tue, 15 Jul 2003 12:33:11 -0300

;; Hello!

;; I extended eev-goto-position so as to link anchors.
;; When you make an anchor and `ee-make-bookmark', you can yank
;; the sexp to junp to the anchor. Otherwise, you can yank
;; the sexp to jump to the position(bookmark.el format).
;; If the directory of linked file is `code-c-d'ed,
;; `ee-make-bookmark' selects an appropriate hyperlink function.
;;
;; e.g. in the case:

;; (code-c-d "myel" "~/emacs/lisp/")
;; (find-myelfile "eev-x.el" '(anchor . "more better ee-goto-position"))
;; (find-myelfile "eev-x.el" '(10004 " (case (car pos-" "pos-spec))\n     "))

;; To do this, you must defadvise `code-c-d' before
;; `ee-load-libraries' in .emacs.

(setq code-d-c-alist nil
      code-c-list nil)
(defadvice code-c-d (before cd-list activate)
  (add-to-list 'code-d-c-alist (cons (expand-file-name d) c))
  (add-to-list 'code-c-list c))


;; --

;;;; [2003/07/18]
;;;; more better ee-goto-position advise
;;;; more better than (to "better ee-goto-position")

(defadvice ee-goto-position (around bookmark activate)
  (if (and pos-spec (listp pos-spec))
      (case (car pos-spec)
        ('anchor
         (ee-goto-position (format ee-anchor-format (cdr pos-spec))))
        (t
         (apply 'ee-bookmark nil pos-spec)))
    ad-do-it))

;;;;[2003/02/01]
;;;; bookmark for eev

(defun ee-bookmark (fn pos front rear)
  (cond ((bufferp fn)
         (switch-to-buffer fn))
        ((stringp fn)
         (find-file fn))
        (t
         (push-mark)))
  (goto-char pos)
  (if (and front (search-forward front (point-max) t))
      (goto-char (match-beginning 0)))
  (if (and rear (search-backward rear (point-min) t))
      (goto-char (match-end 0))))
(defalias 'pos 'ee-bookmark)


;;;[2003/02/12]
;;;replace yank 

(setq ee-bookmark-tmp nil)
(defun ee-yank (arg)
  (interactive "P")
  (let ((print-escape-newlines t))
    (when ee-bookmark-tmp
      (let ((buf (car ee-bookmark-tmp))
            (find-xxxfile (nth 1 ee-bookmark-tmp))
            (pos-or-anchor (nth 2 ee-bookmark-tmp))
            (front (nth 3 ee-bookmark-tmp))
            (rear (nth 4 ee-bookmark-tmp))
            lst)
        (setq ee-bookmark-tmp nil)
        (cond ((stringp pos-or-anchor)
               (setq lst (format "'%S" (cons 'anchor  pos-or-anchor))))
              ((numberp pos-or-anchor)
               (setq lst (format "'%S" (list pos-or-anchor front rear)))))
        (kill-new (if (eq buf (current-buffer))
                      (format "(ee-goto-position %s)\n" lst)
                    (format "(%s%s)\n" find-xxxfile lst)))))
    (call-interactively 'yank)))

(defun ee-make-bookmark (arg)
  (interactive "P")
  (require 'bookmark)
  (let* ((bookmark "ee")
         (bookmark-alist (list (list bookmark (bookmark-make-cell nil)))) 
         (filename (unless arg (bookmark-get-filename bookmark)))
         (front (bookmark-get-front-context-string bookmark))
         (rear (bookmark-get-rear-context-string bookmark))
         (position (bookmark-get-position bookmark))
         (find-xxxfile (ee-make-find-file-function filename))
         (a (ee-search-anchor-around)))
    (setq ee-bookmark-tmp
          (if a
              ;; (buf find-xxxfile anchor)
              (list (current-buffer) find-xxxfile a)
            ;; (buf find-xxxfile position front rear)
            (list (current-buffer) find-xxxfile position front rear)))
    (message "stored position at #<buffer %s> to kill-ring."
	     (buffer-name (current-buffer)))))

(defun ee-search-anchor-around ()
  "Search an anchor around (point)."
  (interactive)
  (save-excursion
    (let ((b (progn (forward-line -2) (point)))
          (e (progn (forward-line 4) (point)))
          (re (format ee-anchor-format "\\(.+\\)")))
      (goto-char b)
      (and (re-search-forward re e t)
           (buffer-substring-no-properties
	    (match-beginning 1) (match-end 1))))))

(defun ee-make-find-file-function-sub (d0)
  (let ((c0 (assoc d0 code-d-c-alist)))
    (cond ((null d0)
           nil)
          (c0
           c0)
          (t
           (ee-make-find-file-function-sub
	    (file-name-directory (substring d0 0 -1)))))))

(defun ee-make-find-file-function (filename)
  (let* ((filename (expand-file-name filename))
         (d (expand-file-name (file-name-directory filename)))
         (c (ee-make-find-file-function-sub d))
         (b (when c
              (substring filename (length (car c)))))
         )
    (cond
     ((string= d (expand-file-name "~/emacs/init.d/"))
      (format "find-elinit %S "
	      (substring (file-name-nondirectory filename) 2 -3)))
     ((string= filename (expand-file-name ee-diary-file-name))
      (format "find-diary "))
     (c (format "find-%sfile %S " (cdr c) b))
     (t (format "find-fline %S\n" (abbreviate-file-name filename))))))



;; > Btw, just to make sure that you know it, the current version is at
;; > <http://www.mat.puc-rio.br/~edrx/eev/> and at
;; > <http://www.mat.puc-rio.br/~edrx/edrx.tgz>, in the eev/ directory, and
;; > these things are updated every few days, as these are the versions
;; > that get installed in the other machines that I use besides the one at
;; > home - oh, and if you prefer you may replace the
;; > "www.mat.puc-rio.br/~edrx" by "angg.twu.net" -
;; 
;; I use the following script to update edrx.tgz.
;; This script is originally extracted from README.
;; 
;; # (find-angg "README")
;; 
;; 
;; #!/bin/sh
;; # update-edrx.sh
;;   # The same commands for downloading as above, and again there's no
;;   # problem if you decide to use other directories...
;;   cd /tmp
;;   rm -f /tmp/edrx.tgz
;;   wget -q http://www.mat.puc-rio.br/~edrx/edrx.tgz
;;   # Unpack in /tmp/edrx/:
;;   cd     ~/eev/edrx/
;;   tar -xzf /tmp/edrx.tgz

;; > Sorry, I'm having to write everything in a hurry, I need to present my
;; > PhD thesis in less than one month, and defend it in less than two
;; > months - but don't worry about "disturbing" me, eev is really a labour
;; > of love for me (and even one of my "reasons for living", I know that
;; > this sounds crazy), and huh, actually your mail is the first piece of
;; > feedback about eev that I receive in a long time... I haven't had the
;; > time to give it more exposure (like adding pages for it at the Emacs
;; > Wiki, trying again to clean it enough so that it can become part of
;; > Emacs, etc) because of lack of time...
;; 
;; I wrote an article about eev in a Japanese mailing list,
;; and it can be found by google(key:eev emacs). But in Japanese:-)
;; 
;; > Here goes a suggestion: on a first sight it would seem that eev (or
;; > "my branch of it") is dead code that no one is maintaining or
;; > updating... so let's pretend that it is really like this, so that you
;; > can feel free to modify it in any way in want, place your version
;; > somewhere on the net, etc; when I get rid of this thesis thing I'll
;; > add pointers to your version on my page, encourage other people to
;; > also create their own versions and make them public, etc, and I'll
;; > start to merge the features...

;; OK, I'll put my version of eev on www.rubyist.net.

;; > About Ruby, I don't use it yet, but I've heard wonders about it and
;; > I'm very curious about it; I'd like to start to learn it and (oops,
;; > I'm switching the subject to eev-ish matters; whatever) to create some
;; > e-scripts about it like what I've done with Lua (that has become one
;; > of my favourite languages)... like these, from
;; > <http://angg.twu.net/e/lua5.e.html#for>:
;; 
;; I'm very curious about Lua; I'll learn from e-scripts about it!
;; I'd like to embed Lua in GNU Screen some day.
;; I want to do more complex thing than 'screen -X eval' and script.

;; > P.P.S.: If your .emacs and diary with e-script parts are on the net
;; > then I'd like to put links to them in my page...
;; 
;; No, my e-scripts is private.... and in Japanese only.....
;; But I'll advocate eev and e-scripts some day.

;; > P.P.P.S.: just curious: how did you find eev and my page? :)
;; I found eev in the ELL.

;; (find-w3m "http://www.cogsci.ed.ac.uk/~stephen/ell.html")
;;
;; --
;; rubikitch

